/**
 * 
 */
package billiardlibrary;

import java.applet.Applet;
import java.awt.BorderLayout;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.util.Timer;
import java.util.TimerTask;
/**
 * @author andrea
 * 
 */
public class Billiard2DApplet extends Applet {
	/**
	 * 
	 */
	private static final long serialVersionUID = -6994886444593978689L;

	Billiard2DPanel pannello;
	PannelloMouseListener p = new PannelloMouseListener();
	Timer t;

	public Billiard2DApplet(){
		Billiard2D b = new Billiard2D(0, 0, 320 - 1, 240 - 1);
		Ball b1 = new Ball(80, 80, 12.5, 0, 30, ""/*"Palla1"*/);
		b.add(b1);
		pannello = new Billiard2DPanel(b);
		this.setLayout(new BorderLayout(8, 8));
		this.add(pannello, BorderLayout.CENTER);
		pannello.addMouseListener(p);						
	}
	
	public void init(){
		System.err.println("init()");
	}
	
	public void start() {
		System.err.println("start()");
		t=new Timer();
		t.schedule(new Prova(),10,10);
	}

	public void stop(){
		System.err.println("stop()");
		t.cancel();
	}
	
	public void destroy(){
		System.err.println("destroy()");
	}
	
	class PannelloMouseListener implements MouseListener {
		public void mouseClicked(MouseEvent e) {
			switch (e.getButton()) {
			case MouseEvent.BUTTON1:
				Ball b = new Ball(e.getX(), e.getY(), 0, 0, 30, ""/*"Palla"
						+ (pannello.b.getBalls() + 1)*/);
				pannello.b.add(b);
				break;
			case MouseEvent.BUTTON3:
				for (int i = 0; i < pannello.b.getBalls(); i++) {
					Ball ba = pannello.b.get(i);
					ba.vx = ba.vx * 1.2;
					ba.vy = ba.vy * 1.2;
				}
				break;
			}
		}

		public void mouseEntered(MouseEvent arg0) {
		}

		public void mouseExited(MouseEvent arg0) {
		}

		public void mousePressed(MouseEvent arg0) {
		}

		public void mouseReleased(MouseEvent arg0) {
		}

	}

	class Prova extends TimerTask {
		public void run() {
			System.out.println("step");
			if (!pannello.b.isAllQuiet(0.05)) {
				pannello.b.updateBallSpeedForBorder();
				pannello.b.updateBallsSpeedForCollision();
				pannello.b.applyFriction(0.001, 1, 0.002, 0.01);
				pannello.b.step();
				pannello.repaint();
			}
		}
	}

}
